/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */
/*
$Header: /afs/andrew.cmu.edu/itc/src/projects/andrew/ams/libs/ms/RCS/newmail.c,v 2.17 1991/12/18 22:03:35 gk5g Exp $
$Source: /afs/andrew.cmu.edu/itc/src/projects/andrew/ams/libs/ms/RCS/newmail.c,v $
*/
/*
        newmail.c -- Routines for accessing incoming mail files in the raw.
*/

char            ams_newmail_rcsid[] = "$Header: /afs/andrew.cmu.edu/itc/src/projects/andrew/ams/libs/ms/RCS/newmail.c,v 2.17 1991/12/18 22:03:35 gk5g Exp $";

#include <andyenv.h>
#include <ms.h>
#include <hdrparse.h>
#include <andrewos.h>

#ifndef _IBMR2
extern char    *malloc();
#endif /* _IBMR2 */

extern char    *rindex(), home[];

extern struct MS_Directory *MyOpenDir;

/* As of 23-May, "Code" is only ever "PROCESSNEW_MBOX" */
/* Note: All of the following code is highly bogus.
  * It supports SPEC, which no longer exists, and the
  * old-style recon, which no longer exists.
  * Code, NumDirInsertions and IsReconstruction are all superfluous.
  */

ProcessNewMail(ThisFileName, ParseSpec, Code, UnlinkFailures, EliErrBuf, EliErrBufLim)
char           *ThisFileName, *ParseSpec, *EliErrBuf;
int             Code, EliErrBufLim;
int            *UnlinkFailures;
{
    char *s;
    Boolean         IsReconstruction;
    int             NumDirInsertions = 0;
    struct MS_Message *Msg;

    if (Code == PROCESSNEW_MBOX) {
	IsReconstruction = FALSE;
    }
    else {
	IsReconstruction = TRUE;
    }
    Msg = (struct MS_Message *) malloc(sizeof(struct MS_Message));
    if (Msg == NULL) {
	AMS_RETURN_ERRCODE(ENOMEM, EIN_MALLOC, EVIA_PROCNEWMSGS);
    }
    bzero(Msg, sizeof(struct MS_Message));
    Msg->OpenFD = -1;
    if (ReadRawFile(ThisFileName, Msg, TRUE)
	 || ParseMessageFromRawBody(Msg)
	 || CheckAuthUid(Msg)
	 || (InventID(Msg)
	     || Flames_HandleNewMessage(Msg, ParseSpec,
					&NumDirInsertions,
					(strncmp(ThisFileName, home, strlen(home))) ? FALSE : TRUE,
					ThisFileName,
					EliErrBuf,
					EliErrBufLim))) {        /* Whew! -- bobg */
	FreeMessage(Msg, TRUE);
	return (mserrcode);
    }
    if (!IsReconstruction) {
	AMS_SET_ATTRIBUTE(Msg->Snapshot, AMS_ATT_UNSEEN);
    }
    if (IsReconstruction) {
	s = rindex(ThisFileName, '/');
	if (s && *++s == '+' && strlen(++s) < AMS_IDSIZE) {
	    strcpy(AMS_ID(Msg->Snapshot), s);
	}
    }

    FreeMessage(Msg, TRUE);
    if (NumDirInsertions == 0) {
	debug(4, ("FLAMES seems to have satisfactorily handled this file, I'll unlink %s\n", ThisFileName));
	unlink(ThisFileName);          /* ignore errors -- might have been
					* renamed out of the way */
    }
    return (0);
}
