/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */
static char *helloa_rcsid = "$Header: /afs/andrew.cmu.edu/itc/src/projects/andrew/atk/examples/ex13/RCS/helloa.c,v 2.6 1991/09/12 16:17:18 bobg Exp $";

/* $Header: /afs/andrew.cmu.edu/itc/src/projects/andrew/atk/examples/ex13/RCS/helloa.c,v 2.6 1991/09/12 16:17:18 bobg Exp $ */

#include <class.h>

#include "helloa.eh"

#include "dataobj.ih"
#include "view.ih"
#include "frame.ih"
#include "im.ih"
#include "hello.ih"

static boolean makeWindow(dobj)
struct dataobject *dobj;
{
    struct view *v;
    struct view *applayer;
    struct frame *frame;
    struct im *im;

    v=(struct view *)class_NewObject(dataobject_ViewName(dobj));
    if(v==NULL)
	return FALSE;

    applayer=view_GetApplicationLayer(v);
    if(applayer==NULL) {
	view_Destroy(v);
	return FALSE;
    }

    frame=frame_New();
    if(frame==NULL) {
	view_DeleteApplicationLayer(v,applayer);
	return FALSE;
    }

    im=im_Create(NULL);
    if(im==NULL) {
	frame_Destroy(frame);
	return FALSE;
    }

    view_SetDataObject(v,dobj);
    frame_SetView(frame,applayer);
    im_SetView(im,frame);

    view_WantInputFocus(v,v);

    return TRUE;

}

boolean helloworldapp__Start(hwapp)
struct helloworldapp *hwapp;
{
    struct helloworld *hw;

    if(!super_Start(hwapp))
	return FALSE;

    hw=helloworld_New();
    if(hw==NULL)
	return FALSE;

    if(!makeWindow((struct dataobject *)hw) ||
       !makeWindow((struct dataobject *)hw)){
	helloworld_Destroy(hw);
	return FALSE;
    }

    return TRUE;
}
