/**********************************************************************
 * File Exchange turnin client
 *
 * $Author: wdc $
 * $Source: /afs/andrew.cmu.edu/itc/src/projects/andrew/contrib/mit/fxlib/clients/RCS/fxbash.c,v $
 * $Header: /afs/andrew.cmu.edu/itc/src/projects/andrew/contrib/mit/fxlib/clients/RCS/fxbash.c,v 1.1 1992/02/13 18:31:20 wdc Exp $
 *
 * Copyright 1989, 1990 by the Massachusetts Institute of Technology.
 *
 * For copying and distribution information, please see the file
 * <mit-copyright.h>.
 **********************************************************************/

#include <mit-copyright.h>

#ifndef lint
static char rcsid_fxbash_c[] = "$Header: /afs/andrew.cmu.edu/itc/src/projects/andrew/contrib/mit/fxlib/clients/RCS/fxbash.c,v 1.1 1992/02/13 18:31:20 wdc Exp $";
#endif /* lint */

#include <stdio.h>
#include <fxcl.h>
#include <sys/types.h>
#include <strings.h>

log(msg)
     char *msg;
{
  static FILE *fp = NULL;
  time_t t;

  if (!fp) {
    fp = popen("/bin/mail brlewis", "w");
    if (!fp) {
      perror("fxbash");
      exit(1);
    }
    fprintf(fp, "To: brlewis@ATHENA.MIT.EDU\nSubject: fxbash test\n");
  }
  if (!msg) {			/* passing NULL means we're done */
    pclose(fp);
    return;
  }
  t = time(NULL);
  fprintf(fp, "%24.24s  %s\n", (char *) ctime(&t), msg);
  return;
}

main(argc, argv)
     int argc;
     char *argv[];
{
  FX *fxp;
  long code;
  Paper p;
  Paperlist_res *plist;
  char *course = "bash";
  char msg[256], host[32];

  paper_clear(&p);
  p.type = TURNEDIN;

  gethostname(host, 32);
  sprintf(msg, "%s started by %s@%s", argv[0], getenv("USER"), host);
  log(msg);

  fxp = fx_open(course, &code);
  sprintf(msg, "After fx_open: %s", error_message(code));
  log(msg);
  if (!fxp) goto BAIL_OUT;

  code = fx_send_file(fxp, &p, "/mit/eos/man/cat1/dump.1");
  sprintf(msg, "After fx_send_file: %s", error_message(code));
  log(msg);

  code = fx_list(fxp, &p, &plist);
  sprintf(msg, "After fx_list: %s", error_message(code));
  log(msg);

  fx_close(fxp);
  strcpy(msg, "done");
  log(msg);

 BAIL_OUT:
  log(NULL);
  exit(0);
}
